"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("../index"));

require("../style");

require("./demo.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Demo1 = /*#__PURE__*/function (_Component) {
  _inherits(Demo1, _Component);

  var _super = _createSuper(Demo1);

  function Demo1() {
    _classCallCheck(this, Demo1);

    return _super.apply(this, arguments);
  }

  _createClass(Demo1, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "demoPadding"
      }, /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "primary"
      }, "primary"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "success"
      }, "success"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "info"
      }, "info"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "warning"
      }, "warning"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "danger"
      }, "danger"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "dark"
      }, "dark"), /*#__PURE__*/_react["default"].createElement("div", {
        className: "divider"
      }), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        shape: "border",
        colors: "primary"
      }, "primary"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        shape: "border",
        colors: "success"
      }, "success"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        shape: "border",
        colors: "info"
      }, "info"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        shape: "border",
        colors: "warning"
      }, "warning"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        shape: "border",
        colors: "danger"
      }, "danger"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        shape: "border",
        colors: "dark"
      }, "dark"), /*#__PURE__*/_react["default"].createElement("div", {
        className: "divider"
      }), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "primary",
        disabled: true
      }, "\u72B6\u6001(disabled)"), /*#__PURE__*/_react["default"].createElement("div", {
        className: "divider"
      }), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        size: "sm",
        colors: "primary"
      }, "\u5C0F\u6309\u94AE"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "primary"
      }, "\u9ED8\u8BA4"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        size: "lg",
        colors: "primary"
      }, "\u5927\u6309\u94AE"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        size: "xg",
        colors: "primary"
      }, "\u5DE8\u5927\u6309\u94AE"), /*#__PURE__*/_react["default"].createElement("div", {
        className: "divider"
      }), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "primary",
        shape: "icon"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-search"
      })), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "primary"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-search"
      }), "Search"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "secondary",
        shape: "icon"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-del"
      })), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "secondary"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-del"
      }), "Delete"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "info",
        shape: "icon"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-cloud-up"
      })), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        colors: "info"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-cloud-up"
      }), "Upload"), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        shape: "icon",
        bordered: true
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-pencil"
      })), /*#__PURE__*/_react["default"].createElement(_index["default"], {
        bordered: true
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "uf uf-pencil"
      }), "Edit"));
    }
  }]);

  return Demo1;
}(_react.Component);

exports["default"] = Demo1;
//# sourceMappingURL=demo.js.map
